
#include <sys/param.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <signal.h>

#include "login.hnt.h"
#include "md5.h"

static void md5(void *p_login_number, char *source, char *result);
static void init_shutdown(int sig);
static int running;

int main(int argc, char **argv)
{
int i;
int udp_sock = -1;
struct sockaddr_in server;
struct hostent *serverent = NULL;
char packet_buffer[64];
u_long *pl_login_number;

if( argc != 2 ){
    printf("Usage: %s <password>\n", argv[0]);
    exit(-1);
    }

running=1;

siginterrupt(SIGTERM, 1);
siginterrupt(SIGHUP, 1);
siginterrupt(SIGINT, 1);
signal (SIGTERM, init_shutdown);
signal (SIGHUP, init_shutdown);
signal (SIGINT, init_shutdown);

bzero(packet_buffer, sizeof(packet_buffer));
bzero(&server, sizeof(struct sockaddr_in));

server.sin_family = AF_INET;
if ( !inet_aton(SERVER_LISTEN, &server.sin_addr) ) {
    if ( (serverent = gethostbyname( SERVER_LISTEN )) == NULL){
	printf("Can't assign server address\n");
	return;
	}
    else server.sin_addr = *(struct in_addr *)serverent->h_addr;
    }
server.sin_port = htons( LOGIN_PORT );

packet_buffer[0] = 1; //protocol version
packet_buffer[1] = LOGIN; //login action
pl_login_number = (u_long *)&packet_buffer[2];
pl_login_number[0] = htonl( (u_long)time(NULL) );
md5((void *)pl_login_number, argv[1], &packet_buffer[6]);

if ( (udp_sock = socket(AF_INET, SOCK_DGRAM, 0)) == -1){
    perror ("Socket erorr");
    return;
    }
for (i = 0; i < 3; i++) {
    if ( sendto(udp_sock, (void *)packet_buffer, 22, 0, 
		(struct sockaddr *)&server, sizeof(struct sockaddr_in)) != 22){
	perror("Sendto error");
	return;
	}
    }
close(udp_sock);
printf("login.hnt started\n");
sleep(60);


while(running){
    pl_login_number = (u_long *)&packet_buffer[2];
    pl_login_number[0] = htonl( (u_long)time(NULL) );
    md5((void *)pl_login_number, argv[1], &packet_buffer[6]);
    if ( (udp_sock = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
        perror ("Socket erorr");
    if ( sendto(udp_sock, (void *)packet_buffer, 22, 0,
                (struct sockaddr *)&server, sizeof(struct sockaddr_in)) != 22)
	perror("Sendto error");
    close(udp_sock);
    if (running != 0) sleep(60);
    }

packet_buffer[1] = LOGOUT; //login action
pl_login_number = (u_long *)&packet_buffer[2];
pl_login_number[0] = htonl( (u_long)time(NULL) );
md5((void *)pl_login_number, argv[1], &packet_buffer[6]);

if ( (udp_sock = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
    perror ("Socket erorr");
for (i = 0; i < 3; i++) {
    if ( sendto(udp_sock, (void *)packet_buffer, 22, 0,
	        (struct sockaddr *)&server, sizeof(struct sockaddr_in)) != 22)
	perror("Sendto error");
    }
				    
close(udp_sock);

}


static void md5(void *p_login_number, char *source, char *result)
{
md5_state_t cur_md5;
md5_init(&cur_md5);
md5_append(&cur_md5, (const unsigned char*)p_login_number, 4);
md5_append(&cur_md5, (const unsigned char*)source, strlen(source));
md5_finish(&cur_md5, result);
}

static void init_shutdown(int sig)
{
running = 0;
}
